// OptionsDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "birthday.h"
#include "birthdayDlg.h"
#include "OptionsDlg.h"
#include "BalloonHelp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld OptionsDlg 


OptionsDlg::OptionsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(OptionsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(OptionsDlg)
		// HINWEIS: Der Klassen-Assistent fgt hier Elementinitialisierung ein
	//}}AFX_DATA_INIT
}


void OptionsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(OptionsDlg)
	DDX_Control(pDX, IDC_CHECK_JUSTLOOK, m_check_justlook);
	DDX_Control(pDX, IDC_CHECK_OK2TRAY, m_check_ok2tray);
	DDX_Control(pDX, IDC_CHECK_RUNONLYONCE, m_check_runonlyonce);
	DDX_Control(pDX, IDC_CHECK_CLOSEONAUTORUN, m_check_closeonautorun);
	DDX_Control(pDX, IDC_CHECK_SAVEFILE, m_check_savefile);
	DDX_Control(pDX, IDC_CHECK_WINDOWPOS, m_check_windowpos);
	DDX_Control(pDX, IDC_CHECK_REGISTRERFILETYPES, m_check_registerfiletypes);
	DDX_Control(pDX, IDC_CHECK_ENABLEREGISTRY, m_check_regenabled);
	DDX_Control(pDX, IDC_CHECK_AUTORUN, m_check_autorun);
	DDX_Control(pDX, IDC_CHECK_ALWAYSONTOP, m_check_alwaysontop);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(OptionsDlg, CDialog)
	//{{AFX_MSG_MAP(OptionsDlg)
	ON_BN_CLICKED(IDC_CHECK_ENABLEREGISTRY, OnCheckEnableregistry)
	ON_BN_CLICKED(IDC_CHECK_AUTORUN, OnCheckAutorun)
	ON_BN_CLICKED(IDC_CHECK_ALWAYSONTOP, OnCheckAlwaysontop)
	ON_BN_CLICKED(IDC_CHECK_WINDOWPOS, OnCheckWindowpos)
	ON_BN_CLICKED(IDC_CHECK_REGISTRERFILETYPES, OnCheckRegistrerfiletypes)
	ON_WM_MOVING()
	ON_WM_SIZE()
	ON_WM_HELPINFO()
	ON_BN_CLICKED(IDC_CHECK_SAVEFILE, OnCheckSavefile)
	ON_BN_CLICKED(IDC_CHECK_CLOSEONAUTORUN, OnCheckCloseonautorun)
	ON_WM_CONTEXTMENU()
	ON_BN_CLICKED(IDC_CHECK_RUNONLYONCE, OnCheckRunonlyonce)
	ON_BN_CLICKED(IDC_CHECK_OK2TRAY, OnCheckOk2tray)
	ON_BN_CLICKED(IDC_CHECK_JUSTLOOK, OnCheckJustlook)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten OptionsDlg 

BOOL OptionsDlg::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	CString strMsg;
	CRect rect;
	//switch between context help and real help
	switch (pHelpInfo->iCtrlId)
	{
		case IDC_CHECK_ENABLEREGISTRY:
			GetDlgItem(IDC_CHECK_ENABLEREGISTRY)->GetWindowRect(&rect);
			strMsg.LoadString( IDS_HELP_OPTIONS_ENABLEREGISTRY);
			break;

		case IDC_CHECK_AUTORUN:
			GetDlgItem(IDC_CHECK_AUTORUN)->GetWindowRect(&rect);
			strMsg.LoadString( IDS_HELP_OPTIONS_AUTORUN);
			break;

		case IDC_CHECK_CLOSEONAUTORUN:
			GetDlgItem(IDC_CHECK_CLOSEONAUTORUN)->GetWindowRect(&rect);
			strMsg.LoadString( IDS_HELP_OPTIONS_CLOSEONAUTORUN);
			break;

		case IDC_CHECK_RUNONLYONCE:
			GetDlgItem(IDC_CHECK_RUNONLYONCE)->GetWindowRect(&rect);
			strMsg.LoadString( IDS_HELP_OPTIONS_RUNONLYONCE);
			break;

		case IDC_CHECK_JUSTLOOK:
			GetDlgItem(IDC_CHECK_JUSTLOOK)->GetWindowRect(&rect);
			strMsg.LoadString( IDS_HELP_OPTIONS_JUSTLOOK);
			break;

		case IDC_CHECK_SAVEFILE:
			GetDlgItem(IDC_CHECK_SAVEFILE)->GetWindowRect(&rect);
			strMsg.LoadString( IDS_HELP_OPTIONS_SAVEFILE);
			break;

		case IDC_CHECK_ALWAYSONTOP:
			GetDlgItem(IDC_CHECK_ALWAYSONTOP)->GetWindowRect(&rect);
			strMsg.LoadString( IDS_HELP_OPTIONS_ALWAYSONTOP);
			break;

		case IDC_CHECK_WINDOWPOS:
			GetDlgItem(IDC_CHECK_WINDOWPOS)->GetWindowRect(&rect);
			strMsg.LoadString( IDS_HELP_OPTIONS_WINDOWPOS);
			break;

		case IDC_CHECK_REGISTRERFILETYPES:
			GetDlgItem(IDC_CHECK_REGISTRERFILETYPES)->GetWindowRect(&rect);
			strMsg.LoadString( IDS_HELP_OPTIONS_REGISTRERFILETYPES);
			break;

		case IDC_CHECK_OK2TRAY:
			GetDlgItem(IDC_CHECK_OK2TRAY)->GetWindowRect(&rect);
			strMsg.LoadString( IDS_HELP_OPTIONS_OK2TRAY);
			break;

		default:
			CFileStatus FileStatus;
			//if file exists, try to show dialog
			if( CFile::GetStatus( strHelpfile, FileStatus) != 0)
			{
				
				HWND hwndHelp = HtmlHelp( m_hWnd, strHelpfile + "::/103 - options.htm>Main", HH_DISPLAY_TOPIC, NULL);
			}
			//No help file? Show about dialog
			else
			{
				CAboutDlg dlgAbout;
				dlgAbout.DoModal();
			}
			return 0;
	}

	CBalloonHelp::LaunchBalloon(MSGBOXTITLE, strMsg, rect.CenterPoint(), IDI_INFORMATION, CBalloonHelp::unCLOSE_ON_MOUSE_MOVE | CBalloonHelp::unCLOSE_ON_KEYPRESS);

	return true;
}

void OptionsDlg::OnCheckEnableregistry() 
{
	if(m_check_regenabled.GetCheck() == 0)
		bdr_regenabled = false;
	else
		bdr_regenabled = true;


	if( bdr_regenabled)
	{
		//Only when autorun is enabled, these may be enabled too
		if( bdr_autorun)
		{
			m_check_closeonautorun	.EnableWindow( true);
			m_check_runonlyonce		.EnableWindow( true);
			m_check_justlook		.EnableWindow( true);

			m_check_closeonautorun	.SetCheck( bdr_closeonautorun);
			m_check_runonlyonce		.SetCheck( bOptRunonlyonce);
			m_check_justlook		.SetCheck( bOptJustlook);
		}
		else
		{
			m_check_closeonautorun	.EnableWindow( false);
			m_check_runonlyonce		.EnableWindow( false);
			m_check_justlook		.EnableWindow( false);

			m_check_closeonautorun	.SetCheck( false);
			m_check_runonlyonce		.SetCheck( false);
			m_check_justlook		.SetCheck( false);
		}

		m_check_alwaysontop			.EnableWindow( true);
		m_check_autorun				.EnableWindow( true);
		m_check_registerfiletypes	.EnableWindow( true);
		m_check_savefile			.EnableWindow( true);
		m_check_windowpos			.EnableWindow( true);
		m_check_ok2tray				.EnableWindow( true);

		m_check_alwaysontop			.SetCheck( bdr_alwaysontop);
		m_check_autorun				.SetCheck( bdr_autorun);
		m_check_registerfiletypes	.SetCheck( bdr_registerfiletypes);
		m_check_savefile			.SetCheck( bdr_savefile);
		m_check_windowpos			.SetCheck( bdr_windowpos);
		m_check_ok2tray				.SetCheck( bOptOK2Tray);

	}
	else
	{
		m_check_alwaysontop			.EnableWindow( false);
		m_check_autorun				.EnableWindow( false);
		m_check_registerfiletypes	.EnableWindow( false);
		m_check_savefile			.EnableWindow( false);
		m_check_windowpos			.EnableWindow( false);
		m_check_closeonautorun		.EnableWindow( false);
		m_check_runonlyonce			.EnableWindow( false);
		m_check_ok2tray				.EnableWindow( false);
		m_check_justlook			.EnableWindow( false);

		m_check_alwaysontop			.SetCheck( false);
		m_check_autorun				.SetCheck( false);
		m_check_registerfiletypes	.SetCheck( false);
		m_check_savefile			.SetCheck( false);
		m_check_windowpos			.SetCheck( false);
		m_check_closeonautorun		.SetCheck( false);
		m_check_runonlyonce			.SetCheck( false);
		m_check_ok2tray				.SetCheck( false);
		m_check_justlook			.SetCheck( false);
	}

}

void OptionsDlg::OnCheckAutorun() 
{
	if(m_check_autorun.GetCheck() == 0)
		bdr_autorun = false;
	else
		bdr_autorun = true;

	if( bdr_autorun)
	{
		m_check_closeonautorun	.EnableWindow( true);
		m_check_runonlyonce		.EnableWindow( true);
		m_check_justlook		.EnableWindow( true);

		m_check_closeonautorun	.SetCheck( bdr_closeonautorun);
		m_check_runonlyonce		.SetCheck( bOptRunonlyonce);
		m_check_justlook		.SetCheck( bOptJustlook);
	}
	else
	{
		m_check_closeonautorun	.EnableWindow( false);
		m_check_runonlyonce		.EnableWindow( false);
		m_check_justlook		.EnableWindow( false);

		m_check_closeonautorun	.SetCheck( false);
		m_check_runonlyonce		.SetCheck( false);
		m_check_justlook		.SetCheck( false);
	}
}

void OptionsDlg::OnCheckAlwaysontop() 
{
	if(m_check_alwaysontop.GetCheck() == 0)
		bdr_alwaysontop = false;
	else
		bdr_alwaysontop = true;
	
}

void OptionsDlg::OnCheckWindowpos() 
{
	if(m_check_windowpos.GetCheck() == 0)
		bdr_windowpos = false;
	else
		bdr_windowpos = true;
	
}

void OptionsDlg::OnCheckRegistrerfiletypes() 
{
	if(m_check_registerfiletypes.GetCheck() == 0)
		bdr_registerfiletypes = false;
	else
		bdr_registerfiletypes = true;
	
}

void OptionsDlg::OnCheckSavefile() 
{
	if(m_check_savefile.GetCheck() == 0)
		bdr_savefile = false;
	else
		bdr_savefile = true;
	
}

void OptionsDlg::OnCheckCloseonautorun() 
{
	if(m_check_closeonautorun.GetCheck() == 0)
		bdr_closeonautorun = false;
	else
		bdr_closeonautorun = true;
	
}

BOOL OptionsDlg::OnInitDialog() 
{
	IsLoaded = false;
	CDialog::OnInitDialog();

	m_check_regenabled.SetCheck( bdr_regenabled);

	if( bdr_regenabled)
	{
		m_check_alwaysontop			.EnableWindow( true);
		m_check_autorun				.EnableWindow( true);
		//Only when autorun is enabled, these may be enabled too
		if( bdr_autorun)
		{
			m_check_closeonautorun	.EnableWindow( true);
			m_check_runonlyonce		.EnableWindow( true);
			m_check_justlook		.EnableWindow( true);

			m_check_closeonautorun	.SetCheck( bdr_closeonautorun);
			m_check_runonlyonce		.SetCheck( bOptRunonlyonce);
			m_check_justlook		.SetCheck( bOptJustlook);
		}
		else
		{
			m_check_closeonautorun	.EnableWindow( false);
			m_check_runonlyonce		.EnableWindow( false);
			m_check_justlook		.EnableWindow( false);

			m_check_closeonautorun	.SetCheck( false);
			m_check_runonlyonce		.SetCheck( false);
			m_check_justlook		.SetCheck( false);
		}

		m_check_registerfiletypes	.EnableWindow( true);
		m_check_savefile			.EnableWindow( true);
		m_check_windowpos			.EnableWindow( true);
		m_check_ok2tray				.EnableWindow( true);

		m_check_alwaysontop			.SetCheck( bdr_alwaysontop);
		m_check_autorun				.SetCheck( bdr_autorun);
		m_check_registerfiletypes	.SetCheck( bdr_registerfiletypes);
		m_check_savefile			.SetCheck( bdr_savefile);
		m_check_windowpos			.SetCheck( bdr_windowpos);
		m_check_ok2tray				.SetCheck( bOptOK2Tray);

	}
	else
	{
		m_check_alwaysontop			.EnableWindow( false);
		m_check_autorun				.EnableWindow( false);
		m_check_registerfiletypes	.EnableWindow( false);
		m_check_savefile			.EnableWindow( false);
		m_check_windowpos			.EnableWindow( false);
		m_check_closeonautorun		.EnableWindow( false);
		m_check_runonlyonce			.EnableWindow( false);
		m_check_ok2tray				.EnableWindow( false);
		m_check_justlook			.EnableWindow( false);

		m_check_alwaysontop			.SetCheck( false);
		m_check_autorun				.SetCheck( false);
		m_check_registerfiletypes	.SetCheck( false);
		m_check_savefile			.SetCheck( false);
		m_check_windowpos			.SetCheck( false);
		m_check_closeonautorun		.SetCheck( false);
		m_check_runonlyonce			.SetCheck( false);
		m_check_ok2tray				.SetCheck( false);
		m_check_justlook			.SetCheck( false);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

void OptionsDlg::OnMoving(UINT nSide, LPRECT lpRect) 
{
	if(IsLoaded == true && IsMagnetOn == true && GetAsyncKeyState(VK_CONTROL) == 0 && GetAsyncKeyState(VK_SHIFT) == 0)
	{
		NewPos = lpRect;
		GetWindowRect(WindowPos);

		WindowSize.right = NewPos->right - NewPos->left;
		WindowSize.bottom = NewPos->bottom - NewPos->top;

		SystemParametersInfo(SPI_GETWORKAREA,0,ScreenSize,0);

		RealPos.top = RealPos.top - WindowPos.top + NewPos->top;
		RealPos.left = RealPos.left - WindowPos.left + NewPos->left;
		RealPos.bottom = RealPos.top + WindowSize.bottom;
		RealPos.right = RealPos.left + WindowSize.right;


		if(!(abs(ScreenSize.top + RealPos.top) <= MagnetSize))
		{
			if(MagnetOnTop)
			{
				NewPos->top = RealPos.top;
				NewPos->bottom = RealPos.bottom;
				MagnetOnTop = false;
				MagnetNowOn = true;
			}
		}
		else
		{
			NewPos->top = ScreenSize.top;
			NewPos->bottom = NewPos->top + WindowSize.bottom;
			MagnetOnTop = true;
			MagnetNowOn = true;
		}

		if(!(abs(ScreenSize.left + RealPos.left) <= MagnetSize))
		{
			if(MagnetOnLeft)
			{
				NewPos->left = RealPos.left;
				NewPos->right = RealPos.right;
				MagnetOnLeft = false;
				MagnetNowOn = true;
			}
		}
		else
		{
			NewPos->left = ScreenSize.left;
			NewPos->right = NewPos->left + WindowSize.right;
			MagnetOnLeft = true;
			MagnetNowOn = true;
		}

		if(!(abs(ScreenSize.bottom - RealPos.bottom) <= MagnetSize))
		{
			if(MagnetOnBottom)
			{
				NewPos->top = RealPos.top;
				NewPos->bottom = RealPos.bottom;
				MagnetOnBottom = false;
				MagnetNowOn = true;
			}
		}
		else
		{
			NewPos->bottom = ScreenSize.bottom;
			NewPos->top = NewPos->bottom - WindowSize.bottom;
			MagnetOnBottom = true;
			MagnetNowOn = true;
		}
		
		if(!(abs(ScreenSize.right - RealPos.right) <= MagnetSize))
		{
			if(MagnetOnRight)
			{
				NewPos->left = RealPos.left;
				NewPos->right = RealPos.right;
				MagnetOnRight = false;
				MagnetNowOn = true;
			}
		}
		else
		{
			NewPos->right = ScreenSize.right;
			NewPos->left = NewPos->right - WindowSize.right;
			MagnetOnRight = true;
			MagnetNowOn = true;
		}


		if(MagnetNowOn)
		{
			lpRect = NewPos;
			MagnetNowOn = false;
		}
		else
		{
			GetWindowRect(RealPos);
		}
		
	}
	else
	{
		GetWindowRect(RealPos);
	}

	CDialog::OnMoving(nSide, lpRect);

	if(!IsLoaded)
	{
		GetWindowRect(RealPos);
		MagnetOnTop = false;
		MagnetOnLeft = false;
		MagnetOnRight = false;
		MagnetOnBottom = false;
		IsLoaded = true;

	}
}

void OptionsDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	GetWindowRect(WindowPos);	
}



void OptionsDlg::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	
}


void OptionsDlg::OnCheckRunonlyonce() 
{
	if( m_check_runonlyonce.GetCheck() == 0)
		bOptRunonlyonce = false;
	else
		bOptRunonlyonce = true;
}

void OptionsDlg::OnCheckOk2tray() 
{
	if( m_check_ok2tray.GetCheck() == 0)
		bOptOK2Tray = false;
	else
		bOptOK2Tray = true;
	
}

void OptionsDlg::OnCheckJustlook() 
{
	if( m_check_justlook.GetCheck() == 0)
		bOptJustlook = false;
	else
		bOptJustlook = true;
	
}
