// birthday.h : Haupt-Header-Datei fr die Anwendung BIRTHDAY
//

#if !defined(AFX_BIRTHDAY_H__9F9C9061_69FC_11D4_BE0B_997D28D6141C__INCLUDED_)
#define AFX_BIRTHDAY_H__9F9C9061_69FC_11D4_BE0B_997D28D6141C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// Hauptsymbole

/////////////////////////////////////////////////////////////////////////////
// CBirthdayApp:
// Siehe birthday.cpp fr die Implementierung dieser Klasse
//
#define MAXBIRTHDAYS	500
#define MSGBOXTITLE "RD birthday reminder"
//Wie oft wird geupdatet? jede Minute
#define ITIMER 60

struct MyTime
{
	int day;
	int month;
	CString year;
	CString DateAsString;
};

struct BdayPerson
{
	CString Name;
	MyTime Date;
	CString Event;
	int yeardiff;
	int daydiffnext;
	int daydifflast;
	bool Checked;
	CString strNextWeekday;
	CString strLastWeekday;
};

struct BdayFile
{
	CString Version;		//Current Birthdayfile version
	CString FileVersion;	//Version the File is Saved
	CString Author, Generator, Content, Loader;
	CString strXSLFile;		//XSL file
	long CountPersons;		//what is the last person in the array
	DWORD Length;
	bool RealError, FileEnd, OnTop, MagnetOn;
	LPTSTR ErrorPos;
	int ShowNext, ShowLast;

	BdayPerson ActBirthPersons[MAXBIRTHDAYS];

public:
	CString GetFileModTime( CString strFilename);
	CString Time2String( int nDay, int nMonth, CString strYear, int nAllYear = -1);
	bool AddPerson( CString strName, CString strEvent, CString strDate);
	bool AddPerson(CString strName, CString strEvent, int nDay, int nMonth, CString strYear, int nAllYear);
	bool AddPerson( CString strName, CString strEvent, int nDay, int nMonth, int nYear, int nAllYear = -1);

	bool Explode( CStringArray *straArray, CString strSeperator, CString strString);
	bool Content2Array( CStringArray *straArray);
	CString GetFileContent( CString *strFileName);
	bool ImportFile( BdayFile *ActBirthFile, CString strFilename);
	void SortItems();
	void InitVariables();
	CString ConvertToXML(CString *Content);
	CString ConvertFromXML(CString *Content);
	void ClearData();
	void CreateContent(bool OnlyChecked, LPCTSTR Type, LPCTSTR FileName);
	void StringToTime(BdayPerson *Person, CString *Content, bool *RealError, LPTSTR *ErrorPos);
	void ConvertEventsFromXML(CString *Content);
	void CalcTimeDiff();
	void CalcTimeDiffOne( int a);

	void Parse(CString Content, BdayFile *ActBirthFile, bool Add);
	void StartParsing(BdayFile *ActBirthFile, bool Add);

	CString GetContent(DWORD Pos, CString *Content, CString *Item);
	CString GetItemType(DWORD Pos, CString *Content);
	DWORD GetNewPos(DWORD Pos, CString *Content);
	CString GetNextItem(DWORD Pos, CString *Content);



	CString FileNameOld;
	CString Title;
	CString FileName;
	DWORD LastPos;
};

class CBirthdayApp : public CWinApp
{
public:
	CBirthdayApp();

// berladungen
	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CBirthdayApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementierung

	//{{AFX_MSG(CBirthdayApp)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_BIRTHDAY_H__9F9C9061_69FC_11D4_BE0B_997D28D6141C__INCLUDED_)
